deps.mk 20 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618
  1. # Copyright (c) 2013-2015, Loïc Hoguin <essen@ninenines.eu>
  2. # This file is part of erlang.mk and subject to the terms of the ISC License.
  3. .PHONY: distclean-deps
  4. # Configuration.
  5. ifdef OTP_DEPS
  6. $(warning The variable OTP_DEPS is deprecated in favor of LOCAL_DEPS.)
  7. endif
  8. IGNORE_DEPS ?=
  9. export IGNORE_DEPS
  10. APPS_DIR ?= $(CURDIR)/apps
  11. export APPS_DIR
  12. DEPS_DIR ?= $(CURDIR)/deps
  13. export DEPS_DIR
  14. REBAR_DEPS_DIR = $(DEPS_DIR)
  15. export REBAR_DEPS_DIR
  16. dep_name = $(if $(dep_$(1)),$(1),$(if $(pkg_$(1)_name),$(pkg_$(1)_name),$(1)))
  17. dep_repo = $(patsubst git://github.com/%,https://github.com/%, \
  18. $(if $(dep_$(1)),$(word 2,$(dep_$(1))),$(pkg_$(1)_repo)))
  19. dep_commit = $(if $(dep_$(1)_commit),$(dep_$(1)_commit),$(if $(dep_$(1)),$(word 3,$(dep_$(1))),$(pkg_$(1)_commit)))
  20. ALL_APPS_DIRS = $(if $(wildcard $(APPS_DIR)/),$(filter-out $(APPS_DIR),$(shell find $(APPS_DIR) -maxdepth 1 -type d)))
  21. ALL_DEPS_DIRS = $(addprefix $(DEPS_DIR)/,$(foreach dep,$(filter-out $(IGNORE_DEPS),$(BUILD_DEPS) $(DEPS)),$(call dep_name,$(dep))))
  22. ifeq ($(filter $(APPS_DIR) $(DEPS_DIR),$(subst :, ,$(ERL_LIBS))),)
  23. ifeq ($(ERL_LIBS),)
  24. ERL_LIBS = $(APPS_DIR):$(DEPS_DIR)
  25. else
  26. ERL_LIBS := $(ERL_LIBS):$(APPS_DIR):$(DEPS_DIR)
  27. endif
  28. endif
  29. export ERL_LIBS
  30. export NO_AUTOPATCH
  31. # Verbosity.
  32. dep_verbose_0 = @echo " DEP " $(1);
  33. dep_verbose_2 = set -x;
  34. dep_verbose = $(dep_verbose_$(V))
  35. # Core targets.
  36. ifdef IS_APP
  37. apps::
  38. else
  39. apps:: $(ALL_APPS_DIRS)
  40. ifeq ($(IS_APP)$(IS_DEP),)
  41. $(verbose) rm -f $(ERLANG_MK_TMP)/apps.log
  42. endif
  43. $(verbose) mkdir -p $(ERLANG_MK_TMP)
  44. # Create ebin directory for all apps to make sure Erlang recognizes them
  45. # as proper OTP applications when using -include_lib. This is a temporary
  46. # fix, a proper fix would be to compile apps/* in the right order.
  47. $(verbose) for dep in $(ALL_APPS_DIRS) ; do \
  48. mkdir -p $$dep/ebin || exit $$?; \
  49. done
  50. $(verbose) for dep in $(ALL_APPS_DIRS) ; do \
  51. if grep -qs ^$$dep$$ $(ERLANG_MK_TMP)/apps.log; then \
  52. :; \
  53. else \
  54. echo $$dep >> $(ERLANG_MK_TMP)/apps.log; \
  55. $(MAKE) -C $$dep IS_APP=1 || exit $$?; \
  56. fi \
  57. done
  58. endif
  59. ifneq ($(SKIP_DEPS),)
  60. deps::
  61. else
  62. deps:: $(ALL_DEPS_DIRS) apps
  63. ifeq ($(IS_APP)$(IS_DEP),)
  64. $(verbose) rm -f $(ERLANG_MK_TMP)/deps.log
  65. endif
  66. $(verbose) mkdir -p $(ERLANG_MK_TMP)
  67. $(verbose) for dep in $(ALL_DEPS_DIRS) ; do \
  68. if grep -qs ^$$dep$$ $(ERLANG_MK_TMP)/deps.log; then \
  69. :; \
  70. else \
  71. echo $$dep >> $(ERLANG_MK_TMP)/deps.log; \
  72. if [ -f $$dep/GNUmakefile ] || [ -f $$dep/makefile ] || [ -f $$dep/Makefile ]; then \
  73. $(MAKE) -C $$dep IS_DEP=1 || exit $$?; \
  74. else \
  75. echo "Error: No Makefile to build dependency $$dep."; \
  76. exit 2; \
  77. fi \
  78. fi \
  79. done
  80. endif
  81. # Deps related targets.
  82. # @todo rename GNUmakefile and makefile into Makefile first, if they exist
  83. # While Makefile file could be GNUmakefile or makefile,
  84. # in practice only Makefile is needed so far.
  85. define dep_autopatch
  86. if [ -f $(DEPS_DIR)/$(1)/erlang.mk ]; then \
  87. $(call erlang,$(call dep_autopatch_appsrc.erl,$(1))); \
  88. $(call dep_autopatch_erlang_mk,$(1)); \
  89. elif [ -f $(DEPS_DIR)/$(1)/Makefile ]; then \
  90. if [ 0 != `grep -c "include ../\w*\.mk" $(DEPS_DIR)/$(1)/Makefile` ]; then \
  91. $(call dep_autopatch2,$(1)); \
  92. elif [ 0 != `grep -ci rebar $(DEPS_DIR)/$(1)/Makefile` ]; then \
  93. $(call dep_autopatch2,$(1)); \
  94. elif [ -n "`find $(DEPS_DIR)/$(1)/ -type f -name \*.mk -not -name erlang.mk -exec grep -i rebar '{}' \;`" ]; then \
  95. $(call dep_autopatch2,$(1)); \
  96. else \
  97. $(call erlang,$(call dep_autopatch_app.erl,$(1))); \
  98. fi \
  99. else \
  100. if [ ! -d $(DEPS_DIR)/$(1)/src/ ]; then \
  101. $(call dep_autopatch_noop,$(1)); \
  102. else \
  103. $(call dep_autopatch2,$(1)); \
  104. fi \
  105. fi
  106. endef
  107. define dep_autopatch2
  108. if [ -f $(DEPS_DIR)/$1/src/$1.app.src.script ]; then \
  109. $(call erlang,$(call dep_autopatch_appsrc_script.erl,$(1))); \
  110. fi; \
  111. $(call erlang,$(call dep_autopatch_appsrc.erl,$(1))); \
  112. if [ -f $(DEPS_DIR)/$(1)/rebar -o -f $(DEPS_DIR)/$(1)/rebar.config -o -f $(DEPS_DIR)/$(1)/rebar.config.script ]; then \
  113. $(call dep_autopatch_fetch_rebar); \
  114. $(call dep_autopatch_rebar,$(1)); \
  115. else \
  116. $(call dep_autopatch_gen,$(1)); \
  117. fi
  118. endef
  119. define dep_autopatch_noop
  120. printf "noop:\n" > $(DEPS_DIR)/$(1)/Makefile
  121. endef
  122. # Overwrite erlang.mk with the current file by default.
  123. ifeq ($(NO_AUTOPATCH_ERLANG_MK),)
  124. define dep_autopatch_erlang_mk
  125. echo "include $(call core_relpath,$(dir $(ERLANG_MK_FILENAME)),$(DEPS_DIR)/app)/erlang.mk" \
  126. > $(DEPS_DIR)/$1/erlang.mk
  127. endef
  128. else
  129. define dep_autopatch_erlang_mk
  130. :
  131. endef
  132. endif
  133. define dep_autopatch_gen
  134. printf "%s\n" \
  135. "ERLC_OPTS = +debug_info" \
  136. "include ../../erlang.mk" > $(DEPS_DIR)/$(1)/Makefile
  137. endef
  138. define dep_autopatch_fetch_rebar
  139. mkdir -p $(ERLANG_MK_TMP); \
  140. if [ ! -d $(ERLANG_MK_TMP)/rebar ]; then \
  141. git clone -q -n -- https://github.com/rebar/rebar $(ERLANG_MK_TMP)/rebar; \
  142. cd $(ERLANG_MK_TMP)/rebar; \
  143. git checkout -q 791db716b5a3a7671e0b351f95ddf24b848ee173; \
  144. $(MAKE); \
  145. cd -; \
  146. fi
  147. endef
  148. define dep_autopatch_rebar
  149. if [ -f $(DEPS_DIR)/$(1)/Makefile ]; then \
  150. mv $(DEPS_DIR)/$(1)/Makefile $(DEPS_DIR)/$(1)/Makefile.orig.mk; \
  151. fi; \
  152. $(call erlang,$(call dep_autopatch_rebar.erl,$(1))); \
  153. rm -f $(DEPS_DIR)/$(1)/ebin/$(1).app
  154. endef
  155. define dep_autopatch_rebar.erl
  156. application:load(rebar),
  157. application:set_env(rebar, log_level, debug),
  158. Conf1 = case file:consult("$(call core_native_path,$(DEPS_DIR)/$1/rebar.config)") of
  159. {ok, Conf0} -> Conf0;
  160. _ -> []
  161. end,
  162. {Conf, OsEnv} = fun() ->
  163. case filelib:is_file("$(call core_native_path,$(DEPS_DIR)/$1/rebar.config.script)") of
  164. false -> {Conf1, []};
  165. true ->
  166. Bindings0 = erl_eval:new_bindings(),
  167. Bindings1 = erl_eval:add_binding('CONFIG', Conf1, Bindings0),
  168. Bindings = erl_eval:add_binding('SCRIPT', "$(call core_native_path,$(DEPS_DIR)/$1/rebar.config.script)", Bindings1),
  169. Before = os:getenv(),
  170. {ok, Conf2} = file:script("$(call core_native_path,$(DEPS_DIR)/$1/rebar.config.script)", Bindings),
  171. {Conf2, lists:foldl(fun(E, Acc) -> lists:delete(E, Acc) end, os:getenv(), Before)}
  172. end
  173. end(),
  174. Write = fun (Text) ->
  175. file:write_file("$(call core_native_path,$(DEPS_DIR)/$1/Makefile)", Text, [append])
  176. end,
  177. Escape = fun (Text) ->
  178. re:replace(Text, "\\\\$$", "\$$$$", [global, {return, list}])
  179. end,
  180. Write("IGNORE_DEPS += edown eper eunit_formatters meck node_package "
  181. "rebar_lock_deps_plugin rebar_vsn_plugin reltool_util\n"),
  182. Write("C_SRC_DIR = /path/do/not/exist\n"),
  183. Write("C_SRC_TYPE = rebar\n"),
  184. Write("DRV_CFLAGS = -fPIC\nexport DRV_CFLAGS\n"),
  185. Write(["ERLANG_ARCH = ", rebar_utils:wordsize(), "\nexport ERLANG_ARCH\n"]),
  186. fun() ->
  187. Write("ERLC_OPTS = +debug_info\nexport ERLC_OPTS\n"),
  188. case lists:keyfind(erl_opts, 1, Conf) of
  189. false -> ok;
  190. {_, ErlOpts} ->
  191. lists:foreach(fun
  192. ({d, D}) ->
  193. Write("ERLC_OPTS += -D" ++ atom_to_list(D) ++ "=1\n");
  194. ({i, I}) ->
  195. Write(["ERLC_OPTS += -I ", I, "\n"]);
  196. ({platform_define, Regex, D}) ->
  197. case rebar_utils:is_arch(Regex) of
  198. true -> Write("ERLC_OPTS += -D" ++ atom_to_list(D) ++ "=1\n");
  199. false -> ok
  200. end;
  201. ({parse_transform, PT}) ->
  202. Write("ERLC_OPTS += +'{parse_transform, " ++ atom_to_list(PT) ++ "}'\n");
  203. (_) -> ok
  204. end, ErlOpts)
  205. end,
  206. Write("\n")
  207. end(),
  208. fun() ->
  209. File = case lists:keyfind(deps, 1, Conf) of
  210. false -> [];
  211. {_, Deps} ->
  212. [begin case case Dep of
  213. {N, S} when is_atom(N), is_list(S) -> {N, {hex, S}};
  214. {N, S} when is_tuple(S) -> {N, S};
  215. {N, _, S} -> {N, S};
  216. {N, _, S, _} -> {N, S};
  217. _ -> false
  218. end of
  219. false -> ok;
  220. {Name, Source} ->
  221. {Method, Repo, Commit} = case Source of
  222. {hex, V} -> {hex, V, undefined};
  223. {git, R} -> {git, R, master};
  224. {M, R, {branch, C}} -> {M, R, C};
  225. {M, R, {ref, C}} -> {M, R, C};
  226. {M, R, {tag, C}} -> {M, R, C};
  227. {M, R, C} -> {M, R, C}
  228. end,
  229. Write(io_lib:format("DEPS += ~s\ndep_~s = ~s ~s ~s~n", [Name, Name, Method, Repo, Commit]))
  230. end end || Dep <- Deps]
  231. end
  232. end(),
  233. fun() ->
  234. case lists:keyfind(erl_first_files, 1, Conf) of
  235. false -> ok;
  236. {_, Files} ->
  237. Names = [[" ", case lists:reverse(F) of
  238. "lre." ++ Elif -> lists:reverse(Elif);
  239. Elif -> lists:reverse(Elif)
  240. end] || "src/" ++ F <- Files],
  241. Write(io_lib:format("COMPILE_FIRST +=~s\n", [Names]))
  242. end
  243. end(),
  244. Write("\n\nrebar_dep: preprocess pre-deps deps pre-app app\n"),
  245. Write("\npreprocess::\n"),
  246. Write("\npre-deps::\n"),
  247. Write("\npre-app::\n"),
  248. PatchHook = fun(Cmd) ->
  249. case Cmd of
  250. "make -C" ++ Cmd1 -> "$$\(MAKE) -C" ++ Escape(Cmd1);
  251. "gmake -C" ++ Cmd1 -> "$$\(MAKE) -C" ++ Escape(Cmd1);
  252. "make " ++ Cmd1 -> "$$\(MAKE) -f Makefile.orig.mk " ++ Escape(Cmd1);
  253. "gmake " ++ Cmd1 -> "$$\(MAKE) -f Makefile.orig.mk " ++ Escape(Cmd1);
  254. _ -> Escape(Cmd)
  255. end
  256. end,
  257. fun() ->
  258. case lists:keyfind(pre_hooks, 1, Conf) of
  259. false -> ok;
  260. {_, Hooks} ->
  261. [case H of
  262. {'get-deps', Cmd} ->
  263. Write("\npre-deps::\n\t" ++ PatchHook(Cmd) ++ "\n");
  264. {compile, Cmd} ->
  265. Write("\npre-app::\n\tCC=$$\(CC) " ++ PatchHook(Cmd) ++ "\n");
  266. {Regex, compile, Cmd} ->
  267. case rebar_utils:is_arch(Regex) of
  268. true -> Write("\npre-app::\n\tCC=$$\(CC) " ++ PatchHook(Cmd) ++ "\n");
  269. false -> ok
  270. end;
  271. _ -> ok
  272. end || H <- Hooks]
  273. end
  274. end(),
  275. ShellToMk = fun(V) ->
  276. re:replace(re:replace(V, "(\\\\$$)(\\\\w*)", "\\\\1(\\\\2)", [global]),
  277. "-Werror\\\\b", "", [{return, list}, global])
  278. end,
  279. PortSpecs = fun() ->
  280. case lists:keyfind(port_specs, 1, Conf) of
  281. false ->
  282. case filelib:is_dir("$(call core_native_path,$(DEPS_DIR)/$1/c_src)") of
  283. false -> [];
  284. true ->
  285. [{"priv/" ++ proplists:get_value(so_name, Conf, "$(1)_drv.so"),
  286. proplists:get_value(port_sources, Conf, ["c_src/*.c"]), []}]
  287. end;
  288. {_, Specs} ->
  289. lists:flatten([case S of
  290. {Output, Input} -> {ShellToMk(Output), Input, []};
  291. {Regex, Output, Input} ->
  292. case rebar_utils:is_arch(Regex) of
  293. true -> {ShellToMk(Output), Input, []};
  294. false -> []
  295. end;
  296. {Regex, Output, Input, [{env, Env}]} ->
  297. case rebar_utils:is_arch(Regex) of
  298. true -> {ShellToMk(Output), Input, Env};
  299. false -> []
  300. end
  301. end || S <- Specs])
  302. end
  303. end(),
  304. PortSpecWrite = fun (Text) ->
  305. file:write_file("$(call core_native_path,$(DEPS_DIR)/$1/c_src/Makefile.erlang.mk)", Text, [append])
  306. end,
  307. case PortSpecs of
  308. [] -> ok;
  309. _ ->
  310. Write("\npre-app::\n\t$$\(MAKE) -f c_src/Makefile.erlang.mk\n"),
  311. PortSpecWrite(io_lib:format("ERL_CFLAGS = -finline-functions -Wall -fPIC -I \\"~s/erts-~s/include\\" -I \\"~s\\"\n",
  312. [code:root_dir(), erlang:system_info(version), code:lib_dir(erl_interface, include)])),
  313. PortSpecWrite(io_lib:format("ERL_LDFLAGS = -L \\"~s\\" -lerl_interface -lei\n",
  314. [code:lib_dir(erl_interface, lib)])),
  315. [PortSpecWrite(["\n", E, "\n"]) || E <- OsEnv],
  316. FilterEnv = fun(Env) ->
  317. lists:flatten([case E of
  318. {_, _} -> E;
  319. {Regex, K, V} ->
  320. case rebar_utils:is_arch(Regex) of
  321. true -> {K, V};
  322. false -> []
  323. end
  324. end || E <- Env])
  325. end,
  326. MergeEnv = fun(Env) ->
  327. lists:foldl(fun ({K, V}, Acc) ->
  328. case lists:keyfind(K, 1, Acc) of
  329. false -> [{K, rebar_utils:expand_env_variable(V, K, "")}|Acc];
  330. {_, V0} -> [{K, rebar_utils:expand_env_variable(V, K, V0)}|Acc]
  331. end
  332. end, [], Env)
  333. end,
  334. PortEnv = case lists:keyfind(port_env, 1, Conf) of
  335. false -> [];
  336. {_, PortEnv0} -> FilterEnv(PortEnv0)
  337. end,
  338. PortSpec = fun ({Output, Input0, Env}) ->
  339. filelib:ensure_dir("$(call core_native_path,$(DEPS_DIR)/$1/)" ++ Output),
  340. Input = [[" ", I] || I <- Input0],
  341. PortSpecWrite([
  342. [["\n", K, " = ", ShellToMk(V)] || {K, V} <- lists:reverse(MergeEnv(PortEnv))],
  343. case $(PLATFORM) of
  344. darwin -> "\n\nLDFLAGS += -flat_namespace -undefined suppress";
  345. _ -> ""
  346. end,
  347. "\n\nall:: ", Output, "\n\n",
  348. "%.o: %.c\n\t$$\(CC) -c -o $$\@ $$\< $$\(CFLAGS) $$\(ERL_CFLAGS) $$\(DRV_CFLAGS) $$\(EXE_CFLAGS)\n\n",
  349. "%.o: %.C\n\t$$\(CXX) -c -o $$\@ $$\< $$\(CXXFLAGS) $$\(ERL_CFLAGS) $$\(DRV_CFLAGS) $$\(EXE_CFLAGS)\n\n",
  350. "%.o: %.cc\n\t$$\(CXX) -c -o $$\@ $$\< $$\(CXXFLAGS) $$\(ERL_CFLAGS) $$\(DRV_CFLAGS) $$\(EXE_CFLAGS)\n\n",
  351. "%.o: %.cpp\n\t$$\(CXX) -c -o $$\@ $$\< $$\(CXXFLAGS) $$\(ERL_CFLAGS) $$\(DRV_CFLAGS) $$\(EXE_CFLAGS)\n\n",
  352. [[Output, ": ", K, " = ", ShellToMk(V), "\n"] || {K, V} <- lists:reverse(MergeEnv(FilterEnv(Env)))],
  353. Output, ": $$\(foreach ext,.c .C .cc .cpp,",
  354. "$$\(patsubst %$$\(ext),%.o,$$\(filter %$$\(ext),$$\(wildcard", Input, "))))\n",
  355. "\t$$\(CC) -o $$\@ $$\? $$\(LDFLAGS) $$\(ERL_LDFLAGS) $$\(DRV_LDFLAGS) $$\(EXE_LDFLAGS)",
  356. case {filename:extension(Output), $(PLATFORM)} of
  357. {[], _} -> "\n";
  358. {_, darwin} -> "\n";
  359. _ -> " -shared\n"
  360. end])
  361. end,
  362. [PortSpec(S) || S <- PortSpecs]
  363. end,
  364. Write("\ninclude $(call core_relpath,$(dir $(ERLANG_MK_FILENAME)),$(DEPS_DIR)/app)/erlang.mk"),
  365. RunPlugin = fun(Plugin, Step) ->
  366. case erlang:function_exported(Plugin, Step, 2) of
  367. false -> ok;
  368. true ->
  369. c:cd("$(call core_native_path,$(DEPS_DIR)/$1/)"),
  370. Ret = Plugin:Step({config, "", Conf, dict:new(), dict:new(), dict:new(),
  371. dict:store(base_dir, "", dict:new())}, undefined),
  372. io:format("rebar plugin ~p step ~p ret ~p~n", [Plugin, Step, Ret])
  373. end
  374. end,
  375. fun() ->
  376. case lists:keyfind(plugins, 1, Conf) of
  377. false -> ok;
  378. {_, Plugins} ->
  379. [begin
  380. case lists:keyfind(deps, 1, Conf) of
  381. false -> ok;
  382. {_, Deps} ->
  383. case lists:keyfind(P, 1, Deps) of
  384. false -> ok;
  385. _ ->
  386. Path = "$(call core_native_path,$(DEPS_DIR)/)" ++ atom_to_list(P),
  387. io:format("~s", [os:cmd("$(MAKE) -C $(call core_native_path,$(DEPS_DIR)/$1) " ++ Path)]),
  388. io:format("~s", [os:cmd("$(MAKE) -C " ++ Path ++ " IS_DEP=1")]),
  389. code:add_patha(Path ++ "/ebin")
  390. end
  391. end
  392. end || P <- Plugins],
  393. [case code:load_file(P) of
  394. {module, P} -> ok;
  395. _ ->
  396. case lists:keyfind(plugin_dir, 1, Conf) of
  397. false -> ok;
  398. {_, PluginsDir} ->
  399. ErlFile = "$(call core_native_path,$(DEPS_DIR)/$1/)" ++ PluginsDir ++ "/" ++ atom_to_list(P) ++ ".erl",
  400. {ok, P, Bin} = compile:file(ErlFile, [binary]),
  401. {module, P} = code:load_binary(P, ErlFile, Bin)
  402. end
  403. end || P <- Plugins],
  404. [RunPlugin(P, preprocess) || P <- Plugins],
  405. [RunPlugin(P, pre_compile) || P <- Plugins],
  406. [RunPlugin(P, compile) || P <- Plugins]
  407. end
  408. end(),
  409. halt()
  410. endef
  411. define dep_autopatch_app.erl
  412. UpdateModules = fun(App) ->
  413. case filelib:is_regular(App) of
  414. false -> ok;
  415. true ->
  416. {ok, [{application, '$(1)', L0}]} = file:consult(App),
  417. Mods = filelib:fold_files("$(call core_native_path,$(DEPS_DIR)/$1/src)", "\\\\.erl$$", true,
  418. fun (F, Acc) -> [list_to_atom(filename:rootname(filename:basename(F)))|Acc] end, []),
  419. L = lists:keystore(modules, 1, L0, {modules, Mods}),
  420. ok = file:write_file(App, io_lib:format("~p.~n", [{application, '$(1)', L}]))
  421. end
  422. end,
  423. UpdateModules("$(call core_native_path,$(DEPS_DIR)/$1/ebin/$1.app)"),
  424. halt()
  425. endef
  426. define dep_autopatch_appsrc_script.erl
  427. AppSrc = "$(call core_native_path,$(DEPS_DIR)/$1/src/$1.app.src)",
  428. AppSrcScript = AppSrc ++ ".script",
  429. Bindings = erl_eval:new_bindings(),
  430. {ok, Conf} = file:script(AppSrcScript, Bindings),
  431. ok = file:write_file(AppSrc, io_lib:format("~p.~n", [Conf])),
  432. halt()
  433. endef
  434. define dep_autopatch_appsrc.erl
  435. AppSrcOut = "$(call core_native_path,$(DEPS_DIR)/$1/src/$1.app.src)",
  436. AppSrcIn = case filelib:is_regular(AppSrcOut) of false -> "$(call core_native_path,$(DEPS_DIR)/$1/ebin/$1.app)"; true -> AppSrcOut end,
  437. case filelib:is_regular(AppSrcIn) of
  438. false -> ok;
  439. true ->
  440. {ok, [{application, $(1), L0}]} = file:consult(AppSrcIn),
  441. L1 = lists:keystore(modules, 1, L0, {modules, []}),
  442. L2 = case lists:keyfind(vsn, 1, L1) of {_, git} -> lists:keyreplace(vsn, 1, L1, {vsn, "git"}); _ -> L1 end,
  443. L3 = case lists:keyfind(registered, 1, L2) of false -> [{registered, []}|L2]; _ -> L2 end,
  444. ok = file:write_file(AppSrcOut, io_lib:format("~p.~n", [{application, $(1), L3}])),
  445. case AppSrcOut of AppSrcIn -> ok; _ -> ok = file:delete(AppSrcIn) end
  446. end,
  447. halt()
  448. endef
  449. define dep_fetch_git
  450. git clone -q -n -- $(call dep_repo,$(1)) $(DEPS_DIR)/$(call dep_name,$(1)); \
  451. cd $(DEPS_DIR)/$(call dep_name,$(1)) && git checkout -q $(call dep_commit,$(1));
  452. endef
  453. define dep_fetch_git-submodule
  454. git submodule update --init -- $(DEPS_DIR)/$1;
  455. endef
  456. define dep_fetch_hg
  457. hg clone -q -U $(call dep_repo,$(1)) $(DEPS_DIR)/$(call dep_name,$(1)); \
  458. cd $(DEPS_DIR)/$(call dep_name,$(1)) && hg update -q $(call dep_commit,$(1));
  459. endef
  460. define dep_fetch_svn
  461. svn checkout -q $(call dep_repo,$(1)) $(DEPS_DIR)/$(call dep_name,$(1));
  462. endef
  463. define dep_fetch_cp
  464. cp -R $(call dep_repo,$(1)) $(DEPS_DIR)/$(call dep_name,$(1));
  465. endef
  466. define dep_fetch_hex.erl
  467. ssl:start(),
  468. inets:start(),
  469. {ok, {{_, 200, _}, _, Body}} = httpc:request(get,
  470. {"https://s3.amazonaws.com/s3.hex.pm/tarballs/$(1)-$(2).tar", []},
  471. [], [{body_format, binary}]),
  472. {ok, Files} = erl_tar:extract({binary, Body}, [memory]),
  473. {_, Source} = lists:keyfind("contents.tar.gz", 1, Files),
  474. ok = erl_tar:extract({binary, Source}, [{cwd, "$(call core_native_path,$(DEPS_DIR)/$1)"}, compressed]),
  475. halt()
  476. endef
  477. # Hex only has a package version. No need to look in the Erlang.mk packages.
  478. define dep_fetch_hex
  479. $(call erlang,$(call dep_fetch_hex.erl,$(1),$(strip $(word 2,$(dep_$(1))))));
  480. endef
  481. define dep_fetch_fail
  482. echo "Error: Unknown or invalid dependency: $(1)." >&2; \
  483. exit 78;
  484. endef
  485. # Kept for compatibility purposes with older Erlang.mk configuration.
  486. define dep_fetch_legacy
  487. $(warning WARNING: '$(1)' dependency configuration uses deprecated format.) \
  488. git clone -q -n -- $(word 1,$(dep_$(1))) $(DEPS_DIR)/$(1); \
  489. cd $(DEPS_DIR)/$(1) && git checkout -q $(if $(word 2,$(dep_$(1))),$(word 2,$(dep_$(1))),master);
  490. endef
  491. define dep_fetch
  492. $(if $(dep_$(1)), \
  493. $(if $(dep_fetch_$(word 1,$(dep_$(1)))), \
  494. $(word 1,$(dep_$(1))), \
  495. $(if $(IS_DEP),legacy,fail)), \
  496. $(if $(filter $(1),$(PACKAGES)), \
  497. $(pkg_$(1)_fetch), \
  498. fail))
  499. endef
  500. define dep_target
  501. $(DEPS_DIR)/$(call dep_name,$1):
  502. $(eval DEP_NAME := $(call dep_name,$1))
  503. $(eval DEP_STR := $(if $(filter-out $1,$(DEP_NAME)),$1,"$1 ($(DEP_NAME))"))
  504. $(verbose) if test -d $(APPS_DIR)/$(DEP_NAME); then \
  505. echo "Error: Dependency" $(DEP_STR) "conflicts with application found in $(APPS_DIR)/$(DEP_NAME)."; \
  506. exit 17; \
  507. fi
  508. $(verbose) mkdir -p $(DEPS_DIR)
  509. $(dep_verbose) $(call dep_fetch_$(strip $(call dep_fetch,$(1))),$(1))
  510. $(verbose) if [ -f $(DEPS_DIR)/$(1)/configure.ac -o -f $(DEPS_DIR)/$(1)/configure.in ] \
  511. && [ ! -f $(DEPS_DIR)/$(1)/configure ]; then \
  512. echo " AUTO " $(1); \
  513. cd $(DEPS_DIR)/$(1) && autoreconf -Wall -vif -I m4; \
  514. fi
  515. - $(verbose) if [ -f $(DEPS_DIR)/$(DEP_NAME)/configure ]; then \
  516. echo " CONF " $(DEP_STR); \
  517. cd $(DEPS_DIR)/$(DEP_NAME) && ./configure; \
  518. fi
  519. ifeq ($(filter $(1),$(NO_AUTOPATCH)),)
  520. $(verbose) if [ "$(1)" = "amqp_client" -a "$(RABBITMQ_CLIENT_PATCH)" ]; then \
  521. if [ ! -d $(DEPS_DIR)/rabbitmq-codegen ]; then \
  522. echo " PATCH Downloading rabbitmq-codegen"; \
  523. git clone https://github.com/rabbitmq/rabbitmq-codegen.git $(DEPS_DIR)/rabbitmq-codegen; \
  524. fi; \
  525. if [ ! -d $(DEPS_DIR)/rabbitmq-server ]; then \
  526. echo " PATCH Downloading rabbitmq-server"; \
  527. git clone https://github.com/rabbitmq/rabbitmq-server.git $(DEPS_DIR)/rabbitmq-server; \
  528. fi; \
  529. ln -s $(DEPS_DIR)/amqp_client/deps/rabbit_common-0.0.0 $(DEPS_DIR)/rabbit_common; \
  530. elif [ "$(1)" = "rabbit" -a "$(RABBITMQ_SERVER_PATCH)" ]; then \
  531. if [ ! -d $(DEPS_DIR)/rabbitmq-codegen ]; then \
  532. echo " PATCH Downloading rabbitmq-codegen"; \
  533. git clone https://github.com/rabbitmq/rabbitmq-codegen.git $(DEPS_DIR)/rabbitmq-codegen; \
  534. fi \
  535. else \
  536. $$(call dep_autopatch,$(DEP_NAME)) \
  537. fi
  538. endif
  539. endef
  540. $(foreach dep,$(BUILD_DEPS) $(DEPS),$(eval $(call dep_target,$(dep))))
  541. ifndef IS_APP
  542. clean:: clean-apps
  543. clean-apps:
  544. $(verbose) for dep in $(ALL_APPS_DIRS) ; do \
  545. $(MAKE) -C $$dep clean IS_APP=1 || exit $$?; \
  546. done
  547. distclean:: distclean-apps
  548. distclean-apps:
  549. $(verbose) for dep in $(ALL_APPS_DIRS) ; do \
  550. $(MAKE) -C $$dep distclean IS_APP=1 || exit $$?; \
  551. done
  552. endif
  553. ifndef SKIP_DEPS
  554. distclean:: distclean-deps
  555. distclean-deps:
  556. $(gen_verbose) rm -rf $(DEPS_DIR)
  557. endif
  558. # External plugins.
  559. DEP_PLUGINS ?=
  560. define core_dep_plugin
  561. -include $(DEPS_DIR)/$(1)
  562. $(DEPS_DIR)/$(1): $(DEPS_DIR)/$(2) ;
  563. endef
  564. $(foreach p,$(DEP_PLUGINS),\
  565. $(eval $(if $(findstring /,$p),\
  566. $(call core_dep_plugin,$p,$(firstword $(subst /, ,$p))),\
  567. $(call core_dep_plugin,$p/plugins.mk,$p))))